#include "mainprogram.h"

#include <QApplication>
#include <QtSingleApplication>
#include <QTranslator>
#include <QLibraryInfo>
#include <QStyleFactory>
#include <QTextCodec>
#include <QDebug>
#include <ukui-log4qt.h>


static QString executeLinuxCmd(QString strCmd)
{
    QProcess p;
    p.start("bash", QStringList() <<"-c" << strCmd);
    p.waitForFinished();
    QString strResult = p.readAllStandardOutput();
    return strResult.toLower();
}

static bool IsHuawei()
{
    QString str = executeLinuxCmd("cat /proc/cpuinfo | grep Hardware");
    if(str.length() == 0)
    {
        return false;
    }

    if(str.indexOf("huawei") != -1 || str.indexOf("pangu") != -1 ||
            str.indexOf("kirin") != -1)
    {
        return true;
    }
    else
    {
        return false;
    }
    return false;
}


int main(int argc, char *argv[])
{
    initUkuiLog4qt("ukui-bluetooth");

    global_ishuawei =  IsHuawei();
    qDebug() << "Ishuawei: "<< global_ishuawei;

    //    QApplication::setStyle(QStyleFactory::create("ukui-default"));
        QApplication::setQuitOnLastWindowClosed(false);
        QApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
        QApplication::setAttribute(Qt::AA_UseHighDpiPixmaps);

    #if (QT_VERSION >= QT_VERSION_CHECK(5, 14, 0))
        QApplication::setHighDpiScaleFactorRoundingPolicy(Qt::HighDpiScaleFactorRoundingPolicy::PassThrough);
    #endif

    QtSingleApplication app(argc, argv);

    if (app.isRunning()) {
        qDebug() << "ukui-bluetooth is Already running ! ! !";
        return EXIT_SUCCESS;
    }
    else
    {
        QTranslator * translator = new QTranslator();;
        translator->load("/usr/share/ukui-bluetooth/translations/ukui-bluetooth_" + QLocale::system().name() + ".qm");
        QApplication::installTranslator(translator);

        MainProgram *w;
        bool intel = QFile::exists("/etc/apt/ota_version");
        w = new MainProgram(intel);
        if( w->exit_flag ){
            return 0;
        }
        return app.exec();
    }
}
